/***********************************
* ================================ *
* FSP - Conceptual preview version *
* ================================ *
*    This is only preview version, *
* that may be used *ONLY* for      *
* embedding /bin/sh scripts into   *
* web pages.                       *
*                                  *
* Distribution: GPL                *
* CopyLeft 10.1999,                *
*    FSP Development Team          *
* "http://www.nmmm.nu/"            *
*    <nmmm@nmmm.nu>                *
*                                  *
***********************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "../mad/mad.h"
#include "../mad/prop.h"
#include "../mad/parsers.h"
#include "../mad/coder.h"
#include "../xml/xml_parser.h"

#define MAX_CONTENT_LENGTH 1024 * 10

#define CONTENT_LENGTH getenv("CONTENT_LENGTH")
#define REQUEST_METHOD getenv("REQUEST_METHOD")
#define HTML_FILE      getenv("PATH_TRANSLATED")

#define QUERY_STRING   "QUERY_STRING"

#define CMDTAG  "%"
#define CMDTAGS (char *[]) { CMDTAG, NULL }

class PropHeadIterator: public PropertiesIterator{
protected:
   StringBuffer *s;
   Coder        *coder;
public:
   PropHeadIterator(StringBuffer *s):
                     s(s),
                     coder(new Coder()){}
   ~PropHeadIterator(){
      delete(coder);
   }
   boolean pass(const char *key, const char *value){
      s->add("export ");

      s->add("ENV_");
      for (unsigned int i=0; i < strlen(key); i++)
         if (strchr("ABCDEFGHIJKLMNOPQRSTUVWXYZ_1234567890", toupper(key[i])))
            s->add(key[i]);

      s->add("=\"");
      s->add(coder->CPPEncode(value, true));
      s->add("\"\n");
      return true;
   }
};

char *readQueryString(char querystr[]){
   if ( !strcmpn(REQUEST_METHOD , "GET" ) )
      return getenv(QUERY_STRING);

   unsigned int size = atoid(CONTENT_LENGTH, 0);

   if (size > MAX_CONTENT_LENGTH)
      size = MAX_CONTENT_LENGTH;

   if (size > 0){
      filegets(querystr, MAX_CONTENT_LENGTH, stdin);
      querystr[MAX_CONTENT_LENGTH] = '\0';
 //Prevantive
   }
   return querystr;
}

void parseQueryString(Properties *p, char querystr[]){
   Coder *coder = new Coder();
   StringParser *qsp = new StringParser(p, coder->URLDecode(querystr), '&','=');
   qsp->parse();
   delete(qsp);
  
   delete(coder);
}

int main(){
   char querystr[MAX_CONTENT_LENGTH + 1] = "\0";
   Properties *p = new Properties();
   parseQueryString(p, readQueryString(querystr));

   StringBuffer *source=new StringBuffer();

   source->add("#!/bin/sh\n");
   source->add("#Generated by FSP (preview conceptual version)\n\n");
   source->add("echo \"Content-Type: text/html\"\n");
   source->add("echo\n\n");
   //Generate Environmental Header
   p->iterate(new PropHeadIterator(source), true);
   source->add("\n");

   Coder *coder = new Coder();
   XMLParser *xml = new XMLParser();

   xml->loadFromFile(HTML_FILE);

   while(!xml->eof()){
      source->add("echo \"");
      source->add(coder->CPPEncode(xml->seekNextTag(CMDTAGS), true));
      source->add("\"\n");

      xml->getNextTag(); // <%>
      source->add(xml->extractDoubleTag(CMDTAG));
      source->add("\n");
   }

   delete(xml);

   system(source->get());

   delete(coder);
   delete(source);
   return 0;
}
 