#ifndef _XMLPARSER_
#define _XMLPARSER_

#include <string.h>

#include "../mad/mad.h"

/*
This library provide control over the XML (or HTML of course) stream.
====================================================================
(C)opyleft 11.1999, Nikolay Mijaylov Mijaylov <nmmm@nmmm.nu>

Simple XML:
----------

<addrbook>
   <peson name="nmmm"    email="nmmm@nmmm.nu"    >
   <peson name="niki"    email="nmmm@hotmail.com">
   <peson name="Nikolay" email="nikolay@nmmm.nu" >
</addrbook>
*/

class XMLParser{
public:
   const long int maxlen = 25 * 1024
;
private:
   long int len;
protected:
   char     data[maxlen + 1];
   long int pos;

   StringBuffer *doublebuffer;

   const char *seekChar(char ch);

   static char *cutTag(char *s);
   static int cmpTag(const char *tag1, const char *tag2);
public:
   XMLParser():doublebuffer(new StringBuffer()){};
   virtual ~XMLParser(){};

   boolean loadFromFile(const char *filename);
   boolean loadFromString(const char *s);

   boolean eof();

   //return text to the next mark
   const char *seekNextTag();
   const char *seekNextTag(char *m[]);

   //return the mark. `seekNextTag()' must be invoked before
   const char *getNextTag();

   //Extract text between `double mark', such as `<p>Hello</p>'
   const char *extractDoubleTag(char *tag);
};

#endif
